#ifndef GPGPU_H
#define GPGPU_H

// A macro to print a TODO message with the line number and file
#define TODOMSG( text ) printf("Still TODO, %s on line %i of %s\n", text, __LINE__, __FILE__);

// A macro to make a cuda call, printing an error message and exiting the program if an error occurs
#define CUDA_SAFE_CALL( value , errorMsg)                                 \
{                                                                         \
  cudaError_t cudaStat = value;                                           \
  if (cudaStat != cudaSuccess)                                            \
  {                                                                       \
    fprintf(stderr, "ERROR: %s [ %s at line %d in file %s ]\n",           \
        errorMsg, cudaGetErrorString(cudaStat), __LINE__, __FILE__ );     \
    exit(EXIT_FAILURE);                                                   \
  }                                                                       \
} 

#endif // GPGPU_H