#include "utilstats.h"
#include "arrayOps.h"
#include "log.h"

double getZ(double Z)
{
  if      ( false )
  {}
  else if ( Z == 0.0001 )
    return -Z_9999;
  else if ( Z == 0.001 )
    return -Z_999;
  else if ( Z == 0.005 )
    return -Z_995;
  else if ( Z == 0.01  )
    return -Z_99;
  else if ( Z == 0.015 )
    return -Z_985;
  else if ( Z == 0.02  )
    return -Z_98;
  else if ( Z == 0.025 )
    return -Z_975;
  else if ( Z == 0.03  )
    return -Z_97;
  else if ( Z == 0.035 )
    return -Z_965;
  else if ( Z == 0.04 )
    return -Z_96;
  else if ( Z == 0.05 )
    return -Z_95;
  else if ( Z == 0.06 )
    return -Z_94;
  else if ( Z == 0.07 )
    return -Z_93;
  else if ( Z == 0.075 )
    return -Z_925;
  else if ( Z == 0.08 )
    return -Z_92;
  else if ( Z == 0.09 )
    return -Z_91;
  else if ( Z == 0.1  )
    return -Z_90;
  else if ( Z == 0.15 )
    return -Z_85;
  else if ( Z == 0.2  )
    return -Z_80;
  else if ( Z == 0.25 )
    return -Z_75;
  else if ( Z == 0.30 )
    return -Z_70;
  else if ( Z == 0.35 )
    return -Z_65;
  else if ( Z == 0.40 )
    return -Z_60;
  else if ( Z == 0.45 )
    return -Z_65;

  else if ( Z == 0.5 )
    return Z_50;

  else if ( Z == 0.55 )
    return Z_55;
  else if ( Z == 0.60 )
    return Z_60;
  else if ( Z == 0.65 )
    return Z_65;
  else if ( Z == 0.70 )
    return Z_70;
  else if ( Z == 0.75 )
    return Z_75;
  else if ( Z == 0.80 )
    return Z_80;
  else if ( Z == 0.85 )
    return Z_85;
  else if ( Z == 0.90 )
    return Z_90;
  else if ( Z == 0.91 )
    return Z_91;
  else if ( Z == 0.92 )
    return Z_92;
  else if ( Z == 0.925 )
    return Z_925;
  else if ( Z == 0.93 )
    return Z_93;
  else if ( Z == 0.94 )
    return Z_94;
  else if ( Z == 0.95 )
    return Z_95;
  else if ( Z == 0.96 )
    return Z_96;
  else if ( Z == 0.965 )
    return Z_965;
  else if ( Z == 0.97 )
    return Z_97;
  else if ( Z == 0.975 )
    return Z_975;
  else if ( Z == 0.98 )
    return Z_98;
  else if ( Z == 0.985 )
    return Z_985;
  else if ( Z == 0.99 )
    return Z_99;
  else if ( Z == 0.995 )
    return Z_995;
  else if ( Z == 0.999 )
    return Z_999;
  else if ( Z == 0.9999 )
    return Z_9999;
  else
  {
    fprintf(stderr, "ERROR: Requesting a Z value I do not have, returning 0 (Z 50)\n");
    return 0;
  }
}

basicStats calcDetails(float *array, unsigned long n)
{
  basicStats details;
  
  if ( !array )
  {
    details.min = 0;
    details.max = 0;
    details.count = 0;
    details.sigma = 0;
    details.spread = 0;
    details.sum = 0;
    return details;
  }

  float *max = ( float* ) malloc ( omp_get_max_threads() * sizeof ( float ) );
  float *min = ( float* ) malloc ( omp_get_max_threads() * sizeof ( float ) );
  double sum = 0;

  details.min = (float)array[0];
  details.max = (float)array[0];

  for ( int i = 0; i < omp_get_max_threads(); i++ )
  {
    max[i] = array[0];
    min[i] = array[0];
  }

#pragma omp parallel
  {
    int thread = omp_get_thread_num();
    int absDiff;

    max[thread] = array[0];
    min[thread] = array[0];

#pragma omp for reduction(+:sum)
    for ( unsigned long i = 0; i < n; i++ )
    {
      min[thread] = MIN2( array[i], min[thread] ) ;
      max[thread] = MAX2( array[i], max[thread] ) ;
      sum += array[i];
    }
  }

  for ( int i = 0; i < omp_get_max_threads(); i++ )
  {
    details.min = MIN2( min[i], (float)details.min ) ;
    details.max = MAX2( max[i], (float)details.max ) ;
  }
  details.sum = sum;
  details.mean = sum/(double)n;
  details.spread = details.max - details.min;

  double sigma = 0;
#pragma omp parallel for reduction(+:sigma)
  for ( unsigned long i = 0; i < n; i++ )
  {
    sigma += (array[i] - details.mean)*(array[i] - details.mean);
  }
  details.sigma = sqrt(sigma/(double)n);

  return details;
}

// kate: indent-mode cstyle; indent-width 2; replace-tabs on; 
